<?php
error_reporting(7);

// ---------------------------------------------------------
//                  BLOXXY - editor blogu
// ---------------------------------------------------------
//
//	2003 (l) -pixy-
//	freeware, beta, copyleft
//	all rights reserved, no responsibility

//  version 0.6b
//  http://bloxxy.srubar.net/

include './getformat.php';
include './bxtags.php';
include './fs.php';
include './comments.php';


$path_to_files = './files';
$bxconfig_file = $path_to_files.'/bxconf.conf';
$config_file = $path_to_files.'/bloxxy-settings.php';
$ftpconfig_file = $path_to_files.'/uploadconf.conf';
$ftpstd_file = $path_to_files.'/ftpstandards.conf';
$bxauthors_file = $path_to_files.'/authors.php';

include($bxconfig_file);

if (!file_exists($path_to_files)) die('Missing directory '.$path_to_files);
if (file_exists($path_to_files)) include($config_file);
else die('Missing file '.$config_file);

include($ftpconfig_file);
include($ftpstd_file);
if (file_exists($bxauthors_file)) include($bxauthors_file);

// --- inits ---

fixPath($bloxxy_URL);
fixPath($path_to_data);
if (!file_exists($path_to_data)) {
  if (!$outact) {$outact = 'globalsettings';
  $startErr[] = 'Zadejte adres pro data';
  $path_to_data = './';
  }
}

$css_file = $path_to_files.'/bloxxy.css';
$str_file_prefix = $path_to_files.'/bloxxy-strings-';
$groups_file = $path_to_data.'/groups.conf';
$items_file = $path_to_data.'/items.conf';
$blogs_file = $path_to_data.'/publications.conf';
$serials_file = $path_to_data.'/serials.conf';

$groupsmeta_file = $path_to_data.'/groupsmeta.conf';
$groupscomm_file = $path_to_data.'/groupscomm.conf';
$groupsarch_file = $path_to_data.'/groupsarch.conf';
$groupsdate_file = $path_to_data.'/groupsdate.conf';
$serial_items_file = $path_to_data.'/serial-items.conf';
if (file_exists($groupsmeta_file)) include($groupsmeta_file);
if (file_exists($groupscomm_file)) include($groupscomm_file);
if (file_exists($groupsarch_file)) include($groupsarch_file);
if (file_exists($groupsdate_file)) include($groupsdate_file);
if (file_exists($serials_file)) include($serials_file);

if (file_exists($groups_file)) include($groups_file);
if (file_exists($blogs_file)) include($blogs_file);
for ($i=0;$i<count($blogs);$i++) {
  if ($blogs[$i]['lastcmtitemcnt']<>'') {
    $xblogs[$i]['lastcmt'][0] = array (
      'itemcnt' =>  $blogs[$i]['lastcmtitemcnt'],
      'template' => $blogs[$i]['lastcmttemplate'],
      'relpath' =>  $blogs[$i]['lastcmtrelpath']
      );
    }
  }

if (file_exists($str_file_prefix.$use_language)) include ($str_file_prefix.$use_language);
else die('Missing strings file for '.$use_language.' language');

$comment_script = 'comments.php';


// --- read groups and items ---

$groups[0] = $BLXS['unassigned'];
$grp_list[] = array();
for ($i=0;$i<count($groups);$i++) {
	$grp_list[$i][0] = $groups[$i];
	$grp_list[$i][1] = $i;
	}

	if (isset($serial)) {
$serials_list[] = array();
foreach ($serial as $sk => $sval)
for ($i=0;$i<=count($serial);$i++){
	$serials_list[$i][0] = isset($serial[$i]['name']) ? $serial[$i]['name'] : $BLXS['unassigned'];
	$serials_list[$i][1] = $i;
	}
	}
	else $serials_list[0][0] = $BLXS['unassigned'];

loadItemsList();
loadSerialsList();

$blog_list[] = array();
for ($i=0;$i<count($blogs);$i++) {
	$blog_list[$i][0] = $blogs[$i]['name'];
	if ($blogs[$i]['groups']=='all') $blog_list[$i][0] .= ' (metablog)';
	$blog_list[$i][1] = $i;
	}

foreach ($_SERVER as $key => $value) {
	${$key} = $value;
}
foreach ($_REQUEST as $key => $value) {
	${$key} = $value;
}



// --- comments ----

if (isset($_POST['addcomment'])) $iscomm = $_POST['addcomment'];
  else $iscomm = false;

if ($iscomm) {
  $FormPosts['spot'] = trim($HTTP_POST_VARS['addcomment']);
  $FormPosts['publ'] = trim($HTTP_POST_VARS['publ']);
  $FormPosts['name'] = trim($HTTP_POST_VARS['item_name']);
  $FormPosts['mail'] = trim($HTTP_POST_VARS['item_mail']);
  $FormPosts['text'] = trim($HTTP_POST_VARS['item_text']);
  $FormPosts['url'] = trim($HTTP_POST_VARS['item_url']);
  $f = $path_to_data.'/'.$FormPosts['spot'].'.txt';
  if (!File_Exists($f)) die($BLXS['Cmt_Err_noCmt']);
  cmtSaveComment();

  publishMetaBlogs();
  
  Die();

  }


function fixPath(&$path) {
	if ($path && eregi('^(.*)\/$',$path,$r)) $path = $r[1];
	}

function eErr($x) {
	global $BLXS;
	echo '<p class="error">'.$BLXS['error'].': '.$x.'</p>'."\n";
	return true;
	}

function errDie($x) { eErr($x); die(); }

include './login.php';
require './gui.php';


// -----------------
// --- PUBLISHER ---
// -----------------


function publishByItem($stamp,$group) {
	global $blogs;
	
	$found = false;
	for ($i=0;$i<count($blogs);$i++) {
		if ( $group>0 && $blogs[$i]['groups']==$group ) {
			publishBlog($i,$stamp);
			$found = true;
			}
		}
	return $found;
	}

function publishBlog($id,$stamp=null) {
	global $BLXS, $blogs, $items;

	$per = $blogs[$id]['archivperiod'];
	$gr = $blogs[$id]['groups'];
	$cnt = $blogs[$id]['itemcnt']; 

 publishArchive($blogs[$id]);

	$list = array();
	$i = 0;    
	reset($items);
	while ($i<$cnt && (list(,$l) = each($items)) ) {
		if ( $gr==$l[1] ) {
			$l[4] = $id;
			$list[] = $l;
			$i++;
			}
		}
	publishPage( $blogs[$id], $list, null, $id );


  $cnt2 = $blogs[$id]['itemcnt2'];
  if ($cnt2 <> 0) {
	  $list = array();
	  $i = 0;
	  reset($items);
	  while ($i<$cnt2 && (list(,$l) = each($items)) ) {
		  if ( $gr==$l[1] ) {
  			$l[4] = $id;
  			$list[] = $l;
  			$i++;
  			}
  		}
	  publishPage( $blogs[$id], $list, "index2" , $id);
    }

	if ($per!='0') {
		if ($stamp) {

			$list = array();
      $list[0] = $items[$stamp]; $list[0][4]=$id; $d1 = $stamp-1;
			publishPage( $blogs[$id], $list, $d1, $id);
  
  $list = null;
  
    reset($items);
			while (list(,$l) = each($items)) {
				if ($l[0]< $stamp && $gr==$l[1] ) {  
					$d1 = $l[0] - 1;
					$l[4] = $id;
					$list[] = $l;
					break;
					}
				}

				publishPage($blogs[$id], $list, $d1, $id);
			}
		else {
			$list = array();
			$metalist = array();
			reset($items);
			while(list(,$l) = each($items)) {
				$stamp = $l[0];
				getPeriod($stamp,$per,$d1,$d2);
				$from = ''.$d1;
				$to = ''.$d2;
				if ($stamp>=$from && $stamp<=$to && $gr==$l[1] ) {
					$l[4] = $id;
					$list[$d1][] = $l;
					}
				}
			while(list($k,$l) = each($list)) {
				publishPage( $blogs[$id], $l, $k, $id);
				
				}
			}

		}
	}


function publishMetaBlogs() {
	global $blogs, $items, $groupsmeta;

	$bCnt = count($blogs);
	$list = array();
	reset($items);
	while (list(,$l) = each($items) ) {
		$found = false;
		for ($i=0;$i<$bCnt;$i++) {
			if ( $blogs[$i]['groups']==$l[1]) {
				$found = true;
				$bID = $i;
				break;
				}
			}
		if ($found) {
			$l[4] = $bID;
			$list[] = $l;
			}
		}
	rsort($list);
	reset($blogs);
	while (list(,$b) = each($blogs) ) {
		if ($b['groups'] == 'all') {
			$sublist = array();
			if (!(strpos($b['name'],'RSS') === false)) {
        for ($i=0;$i<$b['itemcnt'];$i++){
         $sublist[$i] = $list[$i];
        }
      }
      else {
       for ($i=0;$i<$b['itemcnt'];$i++){
       if (!$groupsmeta[$list[$i][1]]) $sublist[$i] = $list[$i];
       else {$b['itemcnt']++; 			continue;}
      }
			}
			publishPage($b, $sublist, 'metablog', null);
		}
	}
}



function publishPage($blg, $list, $pageType, $BlgNo) {
	global $BLXS, $blogs, $bloxxy_URL, $items, $path_to_data, $ntext,$groupscomm,$serial,$serials;

	$indexPath = $blg['indexrelpath'];

  if ($pageType == 'index2'):
  	$fn = $blg['index2template'];
	  $pagePath = $blg['index2relpath'];
  elseif (Is_Int($pageType)):
  	$fn = ($blg['archivdatatemplate']<>'') ? ($blg['archivdatatemplate']) : ($blg['indextemplate']);
  else:
  	$fn = $blg['indextemplate'];
    $pagePath = $blg['indexrelpath'];
  endif;

  if ($pageType == 'serial') {
    $fn = $serial[$BlgNo]['template'];
    $pagePath = $serial[$BlgNo]['serialpatch'];
  }
  

	$ttl = preg_replace('/&(?!\#?[a-z0-9]+;)/i','&#x26;',$blg['name']);
	$desc = preg_replace('/&(?!\#?[a-z0-9]+;)/i','&#x26;',$blg['desc']);
	$publID = $blg['shortname'];

	$archPath = ($blg['archivdatarelpath']<>'') ? ($blg['archivdatarelpath']) : ($blg['archivrelpath']);

  

  
	$fp = fopen($fn,'r') or errDie($BLXS['Err_FileOpen'] . ' ('.$fn.')');
	$tmpl = fread($fp,filesize($fn)) or errDie($BLXS['Err_FileRead'] . ' ('.$fn.')');
	fclose($fp) or errDie($BLXS['Err_FileClose'] . ' ('.$fn.')');
	

	// parse template

	$tmpl = str_replace('%bx_title%',$ttl,$tmpl);
	$tmpl = str_replace('%bx_description%',$desc,$tmpl);
	$tmpl = str_replace('%bx_publid%',$publID,$tmpl);
	$tmpl = str_replace('%bx_archivelink%',$archPath,$tmpl);


  
  
  $publurl = getPageURL(substr($blg['indexrelpath'],0,strrpos($archPath,'/')+1));
  $tmpl = ereg_replace('%bx_publurl%',$publurl,$tmpl);
  
	$tmpl = preg_replace('/%bx_update([^%]*)%/e','formatDate(trim("\\1"),time())',$tmpl);

	$x = split('%bx_day%',$tmpl);
	$pg_hdr = $x[0];
	$rest = $x[1];
	$x = split('%bx_day_end%',$rest);
	$pg_day = $x[0];
	$pg_ftr = $x[1];
	
	if ($pg_day) {
		$tmpl = $pg_day;
		$x = split('%bx_item%',$tmpl);
		$pg_day_hdr = $x[0];
		$rest = $x[1];
		$x = split('%bx_item_end%',$rest);
		$pg_item = $x[0];
		$pg_day_ftr = $x[1];
		}
	else {
		$x = split('%bx_item%',$tmpl);
		$pg_hdr = $x[0];
		$rest = $x[1];
		$x = split('%bx_item_end%',$rest);
		$pg_item = $x[0];
		$pg_ftr = $x[1];
		}

	// fill in template
	if (!is_array($list)) return; 
	$buff = $pg_hdr;
  $jkl = 0; 
	$prevday = '';
	reset($list);
	while(list(,$l) = each($list)) {
		$stamp = $l[0];
		$group = $l[1];
		$author = $l[2];
		$email = $l[3];
		$fromBlg = $blogs[$l[4]];
    $fromBlgNum = $l[4];

    if (!$stamp) continue;

		$thisday = date('yyyy-m-d',$stamp);
		
		if ($pg_day) {
			if ($prevday!=$thisday) {
				if ($prevday) {
					$buff .= $pg_day_ftr;
					}
				$buff .= preg_replace('/%bx_date([^%]*)%/e','formatDate(trim("\\1"),$stamp)',$pg_day_hdr);
				}
			}
		
		$body = $pg_item;

		$body = str_replace('%bx_item_id%',''.$stamp,$body);
		$body = str_replace('%bx_item_author%',$author,$body);
		$body = str_replace('%bx_item_mail%',$email,$body);
		$body = str_replace('%bx_item_authormail%','<a href="mailto:'.$email.'">'.$author.'</a>',$body);
	
    $permalink = getPermalink ($stamp, $fromBlgNum);

		$body = str_replace('%bx_item_permalink%',$permalink,$body);
		$body = str_replace('%bx_item_blogname%',$fromBlg['name'],$body);
		 

		$itemBlogurl = getPageURL($fromBlg['indexrelpath']);
    $itemBlogurl = str_replace('index.html','',$itemBlogurl); // end m add
  
		$body = str_replace('%bx_item_blogurl%',$itemBlogurl,$body);

		$body = preg_replace('/%bx_date([^%]*)%/e','formatDate(trim("\\1"),$stamp)',$body);

		$itemsrc = readItem($stamp);
		// Removing marks for text invisible in filename
    $itemsrc[0] = str_replace('(((','',$itemsrc[0]);
    $itemsrc[0] = str_replace(')))','',$itemsrc[0]);

		$cislo=$stamp;
		
		$itemtext = getItemHTML($itemsrc);
		$itemdesc = getItemDescription($itemsrc);
		$body = str_replace('%bx_item_autotitle%', getSpotname($stamp),$body);
		$body = preg_replace('/%bx_item_autotitle([^%]*)%/e', 'getAutotitle($itemtext,"\\1")',$body);
		$body = preg_replace('/%bx_item_autopreview([^%]*)%/e', 'getItemPreview($itemtext,"\\1",$itemdesc)',$body);

    $Hitemdesc = getHTMLItemDescription($itemsrc);
		$body = str_replace('%bx_item_HTMLpreview%', getItemPreview($itemtext,"\\1",$Hitemdesc),$body);

    $MravItemSrc = $itemsrc;
    if (StrStr($MravItemSrc[0], ':')) $MravItemSrc[0] = '';
    $MravItemText = getItemHTML($MravItemSrc);
    $ItemText = getItemHTML($itemsrc);
    $body = ereg_replace('%bx_item_body%',$ItemText,$body);
    $body = ereg_replace('%bx_item_body_notitle%',$MravItemText,$body);

    $cmtGName = cmtGname($stamp, $fromBlgNum);
if (!$groupscomm[$BlgNo]) $cmtURL = getPageURL($cmtGName);
else $cmtURL = $permalink;
    $body = ereg_replace('%bx_item_commentlink%', $cmtURL,$body);

		$body = ereg_replace("%bx_item_cmtcnt%",'<!--CMTCNT'.$stamp.'-->'.commentsCount($stamp).'<!--CMTCNTEND-->', $body);

		$body = preg_replace('/&(?!\#?[a-z0-9]+;)/i','&#x26;',$body);
		

// Serials parsing
$serialNumber = $serials[$stamp][1];
if (!$serialNumber) $body=cmtDelTmplSec($body, '%bx_serial%', '%bx_serial_end%');
else {
	$body = str_replace('%bx_serialname%',$serial[$serialNumber]['name'],$body);
	$body = str_replace('%bx_serialdescription%',$serial[$serialNumber]['desc'],$body);
	
	$serialpermalink = $bloxxy_URL.'/'.$serial[$serialNumber]['serialpatch'];
	while (ereg('^(.*/)[^/]+/\.\./(.*)$',$serialpermalink,$r)) $serialpermalink = $r[1].$r[2];
	$body = str_replace('%bx_seriallink%',$serialpermalink,$body);
	
	$x = split('%bx_serial%',$body);
	$item_hdr = $x[0];
	$rest = $x[1];
	$x = split('%bx_serial_end%',$rest);
	$pg_serial = $x[0];
	$item_ftr = $x[1];
	
	$x = split('%bx_serialitem%',$pg_serial);
	$serialitem_hdr = $x[0];
	$rest = $x[1];
	$x = split('%bx_serialitem_end%',$rest);
	$pg_templserialitem = $x[0];
	$serialitem_ftr = $x[1];
	
	$seritembuff = '';
	$blgCnt = count($blogs);
	foreach ($serials as $val) {
		$serstamp = $val[0];
		$sernum = $val[1]; 
		if ($sernum != $serialNumber or $serstamp == $stamp) continue;

		for ($seri = 0;$seri < $blgCnt;$seri++) {
			if ($items[$serstamp][1] == $blogs[$seri]['groups']) {
				$serBlgNum = $seri;
				break;				
			}
		}
		
		$pg_serialitem = str_replace('%bx_serialitemname%',getSpotname($serstamp),$pg_templserialitem);
		$pg_serialitem = str_replace('%bx_serialitemlink%',getPermalink($serstamp, $serBlgNum),$pg_serialitem);
		$pg_serialitem = preg_replace('/%bx_serialdate([^%]*)%/e','formatDate(trim("\\1"),$serstamp)',$pg_serialitem);
		$seritembuff .= $pg_serialitem;
	}
	
	$body = $item_hdr.$serialitem_hdr.$seritembuff.$serialitem_ftr.$item_ftr;







}

/*
foreach ($serials as $val) {
	echo $val[0].'->'.$val[1].'<br>';
}*/


$buff .= $body;

    if ($pageType <> 'metablog' && !$groupscomm[$BlgNo] && $pageType != 'serial') {
      if ($archPer!='0'):
        if (Is_Int($pageType)):
          if (!File_Exists($cmtGName)) cmtPublish($stamp, $fromBlgNum);
        endif;
      else:
        if ($pageType==null):
          if (!File_Exists($cmtGName)) cmtPublish($stamp, $fromBlgNum);
        endif;
      endif;
      }


		$prevday = $thisday;
		
		$maxstamp = $stamp;
		$jkl++; // watching number of spots on page
		}


	if ($pg_day) $buff .= $pg_day_ftr;

	$buff .= $pg_ftr;
  $buff = preg_replace('/%bx_date([^%]*)%/e','formatDate(trim("\\1"),$pageType)',$buff);


// Non-item parsing
  if ($jkl < 2) {

  $oneolder = getOneOlder($stamp,$group,1,$BlgNo);
  if ($oneolder != '') {
	$buff = preg_replace('/%bx_older_start%(.*)%bx_older_end%/e','replaceolder(\'\\1\',$oneolder)',$buff);
	//replaceyounger($text,$oneyounger)
  }
  else $buff = preg_replace('/%bx_older_start%(.*)%bx_older_end%/','',$buff);
  

  
  
  
 $oneyounger = getOneYounger($stamp,$group,1,$BlgNo);
  if ($oneyounger != '') {
	  $buff = preg_replace('/%bx_younger_start%(.*)%bx_younger_end%/e','replaceyounger(\'\\1\',$oneyounger)',$buff);
  }
  else $buff = preg_replace('/%bx_younger_start%(.*)%bx_younger_end%/','',$buff);
  
  
  $spotname = getSpotname($stamp); 
  $buff = str_replace('%bx_spotname%',$spotname,$buff);
  
  }
  elseif ($pageType != 'serial') {
      if ($pageType != 'metablog') {
        $oldern = '';
        $oldern = lastN($group,$blg['itemcnt'],$blg['indexoldercount'],$BlgNo);
        $buff = str_replace('%bx_olderlist%',$oldern,$buff);

    }
    else {
      $lastt = lastNmeta($blg['itemcnt'],$blg['indexoldercount']);
      $buff = str_replace('%bx_olderlist%',$lastt,$buff);
      }
     
  }


// Replacing texts 1 to n
replaceBXtext($buff);


// tag %bx_older X,Y%
$buff = preg_replace('/%bx_older ([0-9]+),([0-9]+)%/e','lastNmetaItm(\\1,\\2)',$buff);

// Removing useless mark
$buff = str_replace('%bx_olderlist%','',$buff);

	if (Is_Int($pageType))
  // m 
		$fn = getArchiveFname2($cislo, $fromBlgNum);

  else
		$fn = $pagePath;

$filedir = preg_replace('/%bx_older_end%\.[a-zA-Z0-9]+/','\1',$fn);
if (!file_exists($filedir)) mkRelDir ($filedir);
		
	$fp = fopen($fn,'w') or errDie($BLXS['Err_FileOpen'] . ' ('.$fn.')');
	fwrite($fp,$buff) or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
	fclose($fp) or errDie($BLXS['Err_FileClose'] . ' ('.$fn.')');

	ePar( $BLXS['Publ_WasPublished'] . ': ' . makeLink($ttl.' ('.$fn.')', $fn) );

// Publishing comments on item page

    if ($pageType <> 'metablog' && $groupscomm[$BlgNo]&& Is_Int($pageType)) {
cmtPublish($cislo, $fromBlgNum);
      }

	}


function publishPageArchive($blg) {
	global $BLXS, $blogs, $items,$path_to_data,$ntext;
	
	$fn = ($blg['archivperiod']!='')?$blg['archivperiod'] : $blg['archivtemplate'];
	$ttl = $blg['name'];
	$desc = $blg['desc'];
	$publID = $blg['shortname'];
	$gr = $blg['groups'];
	$per = 'M';
	$archPrefix = $blg['archivprefix'];

	$archPath = $blg['archivrelpath'];

  $archDataPath = ($blg['archivdatarelpath']<>'')? ($blg['archivdatarelpath']) : ($blg['archivrelpath']);

$no = 1;
	reset($items);
	while(list(,$l) = each($items)) {
		$stamp = $l[0];
		getMainPeriod($stamp,'M',$d1,$d2);
		$from = ''.$d1;
		$to = ''.$d2;
			if ($stamp>=$from && $stamp<=$to && ($gr=='all' || $gr==$l[1]) ) {
				$months[$no] = $d1;
				$no++;
			}
		}
$months = array_unique($months);
sort($months);

  $x = strrpos($archDataPath,'/');
	$archPath1 = substr($archDataPath,0,$x+1);
	$archPath2 = substr($archDataPath,$x+1);


	$fp = fopen($fn,'r') or errDie($BLXS['Err_FileOpen'] . ' ('.$fn.')');
	$basetmpl = fread($fp,filesize($fn)) or errDie($BLXS['Err_FileRead'] . ' ('.$fn.')');
	fclose($fp) or errDie($BLXS['Err_FileClose'] . ' ('.$fn.')');



  
  $cnt = count($months);
foreach ($months as $kk) {
	getMainPeriod($kk,$per,$d1,$d2);  
$archs = '';
$tmpl = $basetmpl;
	
	// parse template

	$tmpl = str_replace('%bx_title%',$ttl,$tmpl);
	$tmpl = str_replace('%bx_description%',$desc,$tmpl);
	$tmpl = str_replace('%bx_publid%',$publID,$tmpl);

	
  // mraveniste add begin
  $tmpl = str_replace('%bx_blogurl%',getPageURL($blg['indexrelpath']),$tmpl);
  // mraveniste add end

  replaceBXtext($tmpl);
  
	$x = split('%bx_archiveitem%',$tmpl);
	$pg_hdr = $x[0];
	$rest = $x[1];
	$x = split('%bx_archiveitem_end%',$rest);
	$pg_item = $x[0];
	$pg_ftr = $x[1];

	// fill in template

	$buff = $pg_hdr;

	reset($items);
	while(list(,$l) = each($items)) {
		$stamp = $l[0];
		$from = ''.$d1;
		$to = ''.$d2;
		if ($stamp>=$from && $stamp<=$to && ($gr=='all' || $gr==$l[1])) {
			$archs[$stamp] = $stamp;
			$maxstamp = $stamp;
		}
	}

    
	if (!is_array($archs)) return;
	reset($archs);
	while(list(,$l) = each($archs)) {
		$body = $pg_item;
		$archivURL = getPageURL(getArchiveFname($archPath1, $archPath2, $archPrefix, $l,$publID));

    $spotname = getSpotname($l);
    $spotdescr = getSpotDescr($l,150);
       		
		$body = str_replace('%bx_archivelink%',$archivURL,$body);
		$body = str_replace('%bx_spotname%',$spotname,$body);
		$body = str_replace('%bx_spotdescr%',$spotdescr,$body);
		$body = preg_replace('/%bx_date([^%]*)%/e','formatDate(trim("\\1"),$l)',$body);
		$buff .= $body;
		}

		$buff = preg_replace('/%bx_date([^%]*)%/e','formatDate(trim("\\1"),$maxstamp)',$buff);
		
	$buff .= $pg_ftr;

	$fn = $archPath;
	$fn = preg_replace('/(\.\w+)$/',date('-Y-m',$kk).'\1',$fn);
	$filedir = preg_replace('/(^.*)\.[a-zA-Z0-9]+/','\1',$fn);
if (!file_exists($filedir)) mkRelDir ($filedir);
	$fp = fopen($fn,'w') or errDie($BLXS['Err_FileOpen'] . ' ('.$fn.')');
	fwrite($fp,$buff) or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
	fclose($fp) or errDie($BLXS['Err_FileClose'] . ' ('.$fn.')');

	ePar( $BLXS['Publ_WasPublished'] . ': ' . makeLink($ttl.' - '.$BLXS['archive'].' ('.$fn.')', $fn) );
  }
	}


function publishArchive($blg) {
	global $BLXS, $blogs, $items,$bloxxy_URL,$groupsarch,$path_to_data,$ntext;
	
	$fn =  $blg['archivtemplate'];
	$ttl = $blg['name'];
	$desc = $blg['desc'];
	$publID = $blg['shortname'];
	$gr = $blg['groups'];
	$per = $blg['archivperiod'];
	$per = 'M';
	$archPrefix = $blg['archivprefix'];

	$archPath = $blg['archivrelpath'];


  // mraveniste begin

  $archDataPath = ($blg['archivdatarelpath']<>'')? ($blg['archivdatarelpath']) : ($blg['archivrelpath']);

  $x = strrpos($archDataPath,'/');
	$archPath1 = substr($archDataPath,0,$x+1);
	$archPath2 = substr($archDataPath,$x+1);

  // mraveniste end


	$fp = fopen($fn,'r') or errDie($BLXS['Err_FileOpen'] . ' ('.$fn.')');
	$tmpl = fread($fp,filesize($fn)) or errDie($BLXS['Err_FileRead'] . ' ('.$fn.')');
	fclose($fp) or errDie($BLXS['Err_FileClose'] . ' ('.$fn.')');
	
	// parse template
	$tmpl = ereg_replace('%bx_title%',$ttl,$tmpl);
	$tmpl = ereg_replace('%bx_description%',$desc,$tmpl);
	$tmpl = ereg_replace('%bx_publid%',$publID,$tmpl);

  // mraveniste add begin
  $tmpl = ereg_replace('%bx_blogurl%',getPageURL($blg['indexrelpath']),$tmpl);
  // mraveniste add end

  
  replaceBXtext($tmpl);
  
	$x = split('%bx_archiveitem%',$tmpl);
	$pg_hdr = $x[0];
	$rest = $x[1];
	$x = split('%bx_archiveitem_end%',$rest);
	$pg_item = $x[0];
	$pg_ftr = $x[1];

	// fill in template
	
	$buff = $pg_hdr;

	reset($items);
	while(list(,$l) = each($items)) {
		$stamp = $l[0];
		if ($groupsarch[$publID]) getMainPeriod($stamp,'M',$d1,$d2); else getPeriod($stamp,'M',$d1,$d2);
		$from = ''.$d1;
		$to = ''.$d2;
		if ($stamp>=$from && $stamp<=$to && ($gr=='all' || $gr==$l[1]) )
			$archs[$d1] = ($groupsarch[$publID]) ? $d1 : $stamp;
		}


if (!is_array($archs)) return;
	while(list(,$l) = each($archs)) {
		$body = $pg_item;
		if ($groupsarch[$publID]) {
			$archivURL =  $bloxxy_URL.'/'.$archPath;
			$archivURL = preg_replace('/(\.\w+)$/',date('-Y-m',$l).'\1',$archivURL);
		}
		 else $archivURL = getPageURL(getArchiveFname($archPath1, $archPath2, $archPrefix, $l,$publID));
		while (ereg('^(.*/)[^/]+/\.\./(.*)$',$archivURL,$r)) $archivURL = $r[1].$r[2];

		$spotname = getSpotname($l);
		$spotdescr = getSpotDescr($l,150);

		$body = str_replace('%bx_archivelink%',$archivURL,$body);
		$body = str_replace('%bx_spotname%',$spotname,$body);
		$body = str_replace('%bx_spotdescr%',$spotdescr,$body);
		$body = preg_replace('/%bx_date([^%]*)%/e','formatDate(trim("\\1"),$l)',$body);
		$buff .= $body;
		}

				
	$buff .= $pg_ftr;
	$fn = $archPath;
	$filedir = preg_replace('/(^.*)\.[a-zA-Z0-9]+/','\1',$fn);
if (!file_exists($filedir)) mkRelDir ($filedir);
	$fp = fopen($fn,'w') or errDie($BLXS['Err_FileOpen'] . ' ('.$fn.')');
	fwrite($fp,$buff) or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
	fclose($fp) or errDie($BLXS['Err_FileClose'] . ' ('.$fn.')');
	ePar( $BLXS['Publ_WasPublished'] . ': ' . makeLink($ttl.' - '.$BLXS['archive'].' ('.$fn.')', $fn) );

	if ($groupsarch[$publID]) publishPageArchive($blg);
	}






function getArchiveFname($pre,$post,$mask,$d,$blogid) {
	global $groupsdate;
    $fn = getSpotnameForFilename($d);
    $fn = preg_replace('/\(\(\(.*\)\)\)/','',$fn);
		$fn = ModLink($fn);
$date = ($groupsdate[$blogid]) ? date('Y-m-d-',$d) : '';
	return $pre.$date.$fn.$post;
	}

function getArchiveFname2($id,$blogid) {

  global $blogs,$groupsdate;
  $blog = $blogs[$blogid];
  
	$archPath = ($blog['archivdatarelpath']<>'') ? ($blog['archivdatarelpath']) : ($blog['archivrelpath']);
  $x = strrpos($archPath,'/');
  $pre = substr($archPath,0,$x+1);
  $post = substr($archPath,$x+1);

		$fn = getSpotnameForFilename($id);
		$fn = preg_replace('/\(\(\(.*\)\)\)/','',$fn);
    $fn = ModLink($fn);
$date = ($groupsdate[$blogid]) ? date('Y-m-d-',$id) : '';
	return $pre.$date.$fn.$post;

}

function getPermaPage($id, $blogid) {
  return getPageURL(getArchiveFname2($id, $blogid));
}

function getPermalink($id, $blogid) {
  return getPermaPage($id,$blogid);
}

function getPageURL($fn) {
	global $bloxxy_URL;
	if (substr($fn,0,1)=='/') $fn = substr($fn,1);
	$fn = $bloxxy_URL.'/'.$fn;
	while (ereg('^(.*/)[^/]+/\.\./(.*)$',$fn,$r)) $fn = $r[1].$r[2]; // Removes relative addressing in page URL (..bloxxy/)
	return $fn;
	}

function getPeriod($stamp,$per,&$d1,&$d2) {
$d1 = $stamp - 2;
$d2 = $stamp + 2;
}


function getMainPeriod($stamp,$per,&$d1,&$d2) {
	global $week_starts_moday;
	$d = null;
	$sDate = getdate($stamp);
	if ($per=='W') {
		$wd = $sDate['wday'];
		if ($week_starts_moday) $wd = ($wd+6)%7;
		$day = $sDate['mday']-$wd;
		$d1 = mktime(0,0,0,$sDate['mon'],$day,$sDate['year']);
		$d2 = mktime(23,59,59,$sDate['mon'],$day+7,$sDate['year']);
		}
	elseif ($per=='M') {
		$d1 = mktime(0,0,0,$sDate['mon'],1,$sDate['year']);
		$d2 = mktime(23,59,59,$sDate['mon']+1,0,$sDate['year']);
		}
	elseif ($per=='Y') {
		$d1 = mktime(0,0,0,1,1,$sDate['year']);
		$d2 = mktime(23,59,59,12,31,$sDate['year']);
		}
  elseif ($per=='D') {
		$d1 = mktime(0,0,0,$sDate['mon'],$sDate['mday'],$sDate['year']);
		$d2 = mktime(23,59,59,$sDate['mon'],$sDate['mday'],$sDate['year']);
    }
	else {
		$d1 = null;
		$d2 = null;
		}
	}


function ModLink($fn) {
global $Diacr;

	$fn = StrTr($fn,$Diacr[0],$Diacr[1]);


  	$fn = StrToLower($fn);
		$fn = trim($fn);
    $fn = str_replace('@','o',$fn);
    $fn = str_replace('~','-',$fn);
		$fn = str_replace(' ','-',$fn);
		
		$Xchars = array('"','&#x201c;','&#x201e;','?','!','.',',','&#x2026;',':','(',')','/','"','\\','<','>');		
		$fn = str_replace($Xchars,'',$fn);

$fn = ereg_replace("&#?([a-zA-Z0-9])+;",'-',$fn);
$fn = ereg_replace("[^a-z0-9\-]",'',$fn);
$fn = ereg_replace('\-\-+','-',$fn);

$fn = substr($fn, 0, 100); // max 100 chars in filename

$fn = ereg_replace('\-+$','',$fn);


    return $fn;
}


function getSpotname($id) {

$spotname = getSpotnameForFilename($id);
$spotname = str_replace('(((','',$spotname);
$spotname = str_replace(')))','',$spotname);

		return $spotname;
}

function getSpotnameForFilename($id) {
   $itemsrc = getItem($id);

// Older better and much slower
  //  $itemsrc = readItem($id);
	//	$itemtext = getItemHTML($itemsrc);
	//	$spotname = getAutotitle($itemtext,"\\1");

		$spotname = EReg_Replace ("^:* ", "", strtok($itemsrc, "\n"));
		$spotname = str_replace('\\<','&#x3C;',$spotname );
		$spotname = str_replace('\\>','&#x3E;',$spotname );
		$spotname = str_replace(' - ',' &#x2013; ',$spotname );
    $spotname = chop(preg_replace('/<[^>]*>/s','',$spotname));
    
		return $spotname;
}

function getSpotDescr($id,$max) {
    $itemsrc = readItem($id);
    $itemtext = getItemHTML($itemsrc);
    $itemdesc = getItemDescription($itemsrc);
		$spotdescr = getItemPreview($itemtext,$max,$itemdesc);

		return $spotdescr;
}

function lastN($id,$cnt,$n,$BlgNo = null) {
	global $BLXS, $blogs, $items;

  $last5 = '<ul>';

	$list = array();
	$i = 0;
	reset($items);
	while ($i<($cnt+$n) && (list(,$l) = each($items)) ) {    
    if ( $id==$l[1] ) {
			$i++;
		  if ($i <= $cnt) continue;	
			$stamp = $l[0];
   		$last5 .= '<li><a href="'.getPermalink($stamp,$BlgNo).'">'.getSpotname($stamp).'</a> ('.date('j. n. Y',$stamp).')</li>';
			}
		}
		
  $last5 .= '</ul>'; 

  return $last5;
}

function lastNmeta($cnt,$n) {
	global $BLXS, $blogs, $items, $groupsmeta;

  $last5 = '<ul>'."\n";

	$list = array();
	$i = 0;
	reset($items);
	while ($i<($cnt+$n) && (list(,$l) = each($items)) ) {    
      $group = $l[1];


$BlgCount = count($blogs);
for ($ii=0;$ii<$BlgCount;$ii++ ) {
  if (($blogs[$ii]['groups'] != 'all') && !(isset($groupsArray [$blogs[$ii]['groups']]))) {
    $groupsArray [$blogs[$ii]['groups']] = $ii;
  }
}
$group = $groupsArray [$group];


			$i++;
      if ($groupsmeta[$group]) continue;
		  if ($i <= $cnt) continue;	
			$stamp = $l[0];
   		$last5 .= '<li><a href="'.getPermalink($stamp,$group).'">'.getSpotname($stamp).'</a> ('.date('j. n. Y',$stamp).')</li>'."\n";
		
		}
		
  $last5 .= '</ul>'; 

  return $last5;
}

function lastNmetaItm($cnt,$n) {
	global $BLXS, $blogs, $items, $groupsmeta;

  $last5 = '<ul>'."\n";

	$list = array();
	$i = 0;
	reset($items);
	while ($i<($cnt+$n-1) && (list(,$l) = each($items)) ) {    
      $group = $l[1];

$BlgCount = count($blogs);
for ($ii=0;$ii<$BlgCount;$ii++ ) {
  if (($blogs[$ii]['groups'] != 'all') && !(isset($groupsArray [$blogs[$ii]['groups']]))) {
    $groupsArray [$blogs[$ii]['groups']] = $ii;
  }
}
$group = $groupsArray [$group];

      if ($groupsmeta[$group]) continue;
      $i++;
		  if ($i < $cnt) continue;	
			$stamp = $l[0];
   		$last5 .= '<li><a href="'.getPermalink($stamp,$group).'">'.getSpotname($stamp).'</a></li>'."\n";
		
		}
		
  $last5 .= '</ul>'; 

  return $last5;
}


function getOneOlder($stamp,$id,$n,$BlgNo) {
	global $BLXS, $blogs, $items;

	$i = 0;
	reset($items);
	while (($i < $n) && (list(,$l) = each($items)) ) {    
    if ( $id==$l[1] ) {
		  if ($l[0] >= $stamp) continue;	
	    $i++;
			$stamp = $l[0];

		$permalink = getPermalink($stamp,$BlgNo);
		$spotname = getSpotname($stamp);
    		$last5[0] = '<a href="'.$permalink.'">'.$spotname.'</a>';
		$last5[1] = $permalink;
		$last5[2] =  $spotname;
		$last5[3] =  $stamp;
			}
		}

  if ($i == 0) $last5 = '';

  return $last5;
}

function getOneYounger($stamp,$id,$n,$BlgNo) {
	global $BLXS, $blogs, $items;

	$cnt = $blogs[$id]['itemcnt'];


  
 	reset($items);
 	while ((list(,$l) = each($items)) ) {     
     if ( $id==$l[1] ) {
		  if ($l[0] > $stamp) {$stampnow = $l[0];$group = $l[1];}
        
      else {
			$i++;
			if ($stampnow == '') {return $last5='';}
 			$stamp = $stampnow;
			$permalink = getPermalink($stamp,$BlgNo);
			$spotname = getSpotname($stamp);
    		$last5[0] = '<a href="'.$permalink.'">'.$spotname.'</a>';
		$last5[1] = $permalink;
		$last5[2] =  $spotname;
		$last5[3] =  $stamp;
 

 			break;
      }
 		}
 	}	

   if ($i == 0) $last5 = '';


  return $last5;
}


function getItem($id) {
  global $path_to_data;
  $filename =$path_to_data.'/'.$id.'.txt';
	if (file_exists($filename)){	$fd = fopen ($filename, "r");
		$spot = fread ($fd, filesize ($filename));
	}
	
	return 	$spot;
}

function replaceBXtext(&$buff) {
	global $path_to_data,$ntext;
	for ($r=1;$r<=$ntext;$r++){
	  $filename = $path_to_data.'/bxtext'.$r.'.txt';
	  if (file_exists($filename))$bxtext = file($filename);
	  $bxtext = getItemHTML($bxtext);
	  $buff = str_replace('%bx_bxtext'.$r.'%',$bxtext,$buff);
	}
return $buff;
	
}


function publishSerial($num) {
 global $serials, $serial, $items,$blogs;
$i=0;
$bCnt = count($blogs);
	
		while (list(,$l) = each($items) ) {
		$found = false;
		for ($i=0;$i<$bCnt;$i++) {
			if ( $blogs[$i]['groups']==$l[1] && $serials[$l[0]][1] == $num) {
				$found = true;
				$bID = $i;
				break;
				}
			}
		if ($found) {
			$l[4] = $bID;
			$list[] = $l;
			}
		}
	
	publishPage( $serial[$num], $list, 'serial', $num );

}

function replaceyounger($text,$oneyounger) {
	if (get_magic_quotes_gpc()) $text=stripslashes($text);

	$text = str_replace('%bx_oneyounger%',$oneyounger[0],$text);
	$text = str_replace('%bx_oneyoungerurl%',$oneyounger[1],$text);
	$text = str_replace('%bx_oneyoungername%',$oneyounger[2],$text);
	$text = preg_replace('/%bx_itemdate([^%]*)%/e','formatDate(trim("\\1"),$oneyounger[3])',$text);
	return $text;
	
}

function replaceolder($text,$oneyounger) {
	if (get_magic_quotes_gpc()) $text=stripslashes($text);

	$text = str_replace('%bx_oneolder%',$oneyounger[0],$text);
	$text = str_replace('%bx_oneolderurl%',$oneyounger[1],$text);
	$text = str_replace('%bx_oneoldername%',$oneyounger[2],$text);
	$text = preg_replace('/%bx_itemdate([^%]*)%/e','formatDate(trim("\\1"),$oneyounger[3])',$text);
	return $text;
	
}




?>
